package eu.vodofrede.immersivexp;

import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.minecraft.block.BlockState;
import net.minecraft.block.CropBlock;
import net.minecraft.block.MelonBlock;
import net.minecraft.block.SweetBerryBushBlock;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.tag.BlockTags;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class Events {
    public static void init() {
        PlayerBlockBreakEvents.AFTER.register((world, player, pos, state, entity) -> {
            // TODO: Make experience amount configurable
            if (world instanceof ServerWorld) {
                if (state.getBlock() instanceof CropBlock || state.getBlock() instanceof MelonBlock) {
                    Util.spawnExp((ServerWorld) world, pos, 1, 1);
                }

                if (state.isIn(BlockTags.LOGS)) {
                    boolean holdingAxe = player.isHolding(Registry.ITEM.get(new Identifier("minecraft:axe")));
                    boolean isGrown = Util.isTreeNaturallyGrown(world, pos);

                    if (holdingAxe && isGrown) {
                        Util.spawnExp((ServerWorld) world, pos, 1, 4);
                    }
                }
            }
        });

        UseBlockCallback.EVENT.register(((player, world, hand, hitResult) -> {
            // TODO: Make experience amount configurable
            BlockState state = world.getBlockState(hitResult.getBlockPos());

            if (state.getBlock() instanceof SweetBerryBushBlock && world instanceof ServerWorld) {
                Util.spawnExp((ServerWorld) world, hitResult.getBlockPos(), 1, 1);
            }

            return ActionResult.PASS;
        }));
    }
}
